# frozen_string_literal: true

# #Medical Network Professional Claims v3
#
# Reference for developers
#
# OpenAPI spec version: v3
#
# Generated by: https://github.com/swagger-api/swagger-codegen.git
# Swagger Codegen version: 2.4.19
#

require 'date'

module ChangeHealthcare
  module ProfessionalClaims
    module SwaggerClient
      class ClaimReference
        attr_accessor :claim_type, :correlation_id, :customer_claim_number, :format_version, :patient_control_number,
                      :payer_id, :rhclaim_number, :submitter_id, :time_of_response

        # Attribute mapping from ruby-style variable name to JSON key.
        def self.attribute_map
          {
            claim_type: :claimType,
            correlation_id: :correlationId,
            customer_claim_number: :customerClaimNumber,
            format_version: :formatVersion,
            patient_control_number: :patientControlNumber,
            payer_id: :payerID,
            rhclaim_number: :rhclaimNumber,
            submitter_id: :submitterId,
            time_of_response: :timeOfResponse
          }
        end

        # Attribute type mapping.
        def self.swagger_types
          {
            claim_type: :String,
            correlation_id: :String,
            customer_claim_number: :String,
            format_version: :String,
            patient_control_number: :String,
            payer_id: :String,
            rhclaim_number: :String,
            submitter_id: :String,
            time_of_response: :String
          }
        end

        # Initializes the object
        # @param [Hash] attributes Model attributes in the form of hash
        def initialize(attributes = {})
          return unless attributes.is_a?(Hash)

          # convert string to symbol for hash key
          attributes = attributes.transform_keys(&:to_sym)

          self.claim_type = attributes[:claimType] if attributes.key?(:claimType)

          self.correlation_id = attributes[:correlationId] if attributes.key?(:correlationId)

          self.customer_claim_number = attributes[:customerClaimNumber] if attributes.key?(:customerClaimNumber)

          self.format_version = attributes[:formatVersion] if attributes.key?(:formatVersion)

          self.patient_control_number = attributes[:patientControlNumber] if attributes.key?(:patientControlNumber)

          self.payer_id = attributes[:payerID] if attributes.key?(:payerID)

          self.rhclaim_number = attributes[:rhclaimNumber] if attributes.key?(:rhclaimNumber)

          self.submitter_id = attributes[:submitterId] if attributes.key?(:submitterId)

          self.time_of_response = attributes[:timeOfResponse] if attributes.key?(:timeOfResponse)
        end

        # Show invalid properties with the reasons. Usually used together with valid?
        # @return Array for valid properties with the reasons
        def list_invalid_properties
          []
        end

        # Check to see if the all the properties in the model are valid
        # @return true if the model is valid
        def valid?
          true
        end

        # Checks equality by comparing each attribute.
        # @param [Object] Object to be compared
        def ==(other)
          return true if equal?(other)

          self.class == other.class &&
            claim_type == other.claim_type &&
            correlation_id == other.correlation_id &&
            customer_claim_number == other.customer_claim_number &&
            format_version == other.format_version &&
            patient_control_number == other.patient_control_number &&
            payer_id == other.payer_id &&
            rhclaim_number == other.rhclaim_number &&
            submitter_id == other.submitter_id &&
            time_of_response == other.time_of_response
        end

        # @see the `==` method
        # @param [Object] Object to be compared
        def eql?(other)
          self == other
        end

        # Calculates hash code according to all attributes.
        # @return [Fixnum] Hash code
        def hash
          [claim_type, correlation_id, customer_claim_number, format_version, patient_control_number, payer_id,
           rhclaim_number, submitter_id, time_of_response].hash
        end

        # Builds the object from hash
        # @param [Hash] attributes Model attributes in the form of hash
        # @return [Object] Returns the model itself
        def build_from_hash(attributes)
          return nil unless attributes.is_a?(Hash)

          self.class.swagger_types.each_pair do |key, type|
            if type =~ /\AArray<(.*)>/i
              # check to ensure the input is an array given that the attribute
              # is documented as an array but the input is not
              if attributes[self.class.attribute_map[key]].is_a?(Array)
                send("#{key}=", attributes[self.class.attribute_map[key]].map do |v|
                                  _deserialize(Regexp.last_match(1), v)
                                end)
              end
            elsif !attributes[self.class.attribute_map[key]].nil?
              send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
            end
          end

          self
        end

        # Deserializes the data based on type
        # @param string type Data type
        # @param string value Value to be deserialized
        # @return [Object] Deserialized data
        def _deserialize(type, value)
          case type.to_sym
          when :DateTime
            DateTime.parse(value)
          when :Date
            Date.parse(value)
          when :String
            value.to_s
          when :Integer
            value.to_i
          when :Float
            value.to_f
          when :BOOLEAN
            if value.to_s =~ /\A(true|t|yes|y|1)\z/i
              true
            else
              false
            end
          when :Object
            # generic object (usually a Hash), return directly
            value
          when /\AArray<(?<inner_type>.+)>\z/
            inner_type = Regexp.last_match[:inner_type]
            value.map { |v| _deserialize(inner_type, v) }
          when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
            k_type = Regexp.last_match[:k_type]
            v_type = Regexp.last_match[:v_type]
            {}.tap do |hash|
              value.each do |k, v|
                hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
              end
            end
          else # model
            temp_model = SwaggerClient.const_get(type).new
            temp_model.build_from_hash(value)
          end
        end

        # Returns the string representation of the object
        # @return [String] String presentation of the object
        def to_s
          to_hash.to_s
        end

        # to_body is an alias to to_hash (backward compatibility)
        # @return [Hash] Returns the object in the form of hash
        def to_body
          to_hash
        end

        # Returns the object in the form of hash
        # @return [Hash] Returns the object in the form of hash
        def to_hash
          hash = {}
          self.class.attribute_map.each_pair do |attr, param|
            value = send(attr)
            next if value.nil?

            hash[param] = _to_hash(value)
          end
          hash
        end

        # Outputs non-array value in the form of hash
        # For object, use to_hash. Otherwise, just return the value
        # @param [Object] value Any valid value
        # @return [Hash] Returns the value in the form of hash
        def _to_hash(value)
          if value.is_a?(Array)
            value.compact.map { |v| _to_hash(v) }
          elsif value.is_a?(Hash)
            {}.tap do |hash|
              value.each { |k, v| hash[k] = _to_hash(v) }
            end
          elsif value.respond_to? :to_hash
            value.to_hash
          else
            value
          end
        end
      end
    end
  end
end
