# frozen_string_literal: true

# #Medical Network Professional Claims v3
#
# Reference for developers
#
# OpenAPI spec version: v3
#
# Generated by: https://github.com/swagger-api/swagger-codegen.git
# Swagger Codegen version: 2.4.19
#

require 'date'

module ChangeHealthcare
  module ProfessionalClaims
    module SwaggerClient
      class OtherSubscriberName
        attr_accessor(
          :other_insured_additional_identifier,
          :other_insured_address,
          :other_insured_first_name,
          :other_insured_identifier,
          :other_insured_last_name,
          :other_insured_middle_name,
          :other_insured_name_suffix
        )

        ##
        # Allowed Values are:
        #
        # - 'II' Standard Unique Health Identifier for each Individual in the United States
        # - 'MI' Member Identification Number
        #
        # @return [String]
        attr_reader :other_insured_identifier_type_code

        ##
        # Allowed Values are:
        #
        # - '1' Person
        # - '2' Non-Person Entity
        #
        # @return [String]
        attr_accessor :other_insured_qualifier

        class EnumAttributeValidator
          attr_reader :datatype, :allowable_values

          def initialize(datatype, allowable_values)
            @allowable_values = allowable_values.map do |value|
              case datatype.to_s
              when /Integer/i
                value.to_i
              when /Float/i
                value.to_f
              else
                value
              end
            end
          end

          def valid?(value)
            !value || allowable_values.include?(value)
          end
        end

        # Attribute mapping from ruby-style variable name to JSON key.
        def self.attribute_map
          {
            other_insured_additional_identifier: :otherInsuredAdditionalIdentifier,
            other_insured_address: :otherInsuredAddress,
            other_insured_first_name: :otherInsuredFirstName,
            other_insured_identifier: :otherInsuredIdentifier,
            other_insured_identifier_type_code: :otherInsuredIdentifierTypeCode,
            other_insured_last_name: :otherInsuredLastName,
            other_insured_middle_name: :otherInsuredMiddleName,
            other_insured_name_suffix: :otherInsuredNameSuffix,
            other_insured_qualifier: :otherInsuredQualifier
          }
        end

        # Attribute type mapping.
        def self.swagger_types
          {
            other_insured_additional_identifier: :String,
            other_insured_address: :Address,
            other_insured_first_name: :String,
            other_insured_identifier: :String,
            other_insured_identifier_type_code: :String,
            other_insured_last_name: :String,
            other_insured_middle_name: :String,
            other_insured_name_suffix: :String,
            other_insured_qualifier: :String
          }
        end

        # Initializes the object
        # @param [Hash] attributes Model attributes in the form of hash
        def initialize(attributes = {})
          return unless attributes.is_a?(Hash)

          # convert string to symbol for hash key
          attributes = attributes.transform_keys(&:to_sym)

          self.other_insured_additional_identifier = attributes[:otherInsuredAdditionalIdentifier] if attributes.key?(:otherInsuredAdditionalIdentifier)

          self.other_insured_address = attributes[:otherInsuredAddress] if attributes.key?(:otherInsuredAddress)

          self.other_insured_first_name = attributes[:otherInsuredFirstName] if attributes.key?(:otherInsuredFirstName)

          self.other_insured_identifier = attributes[:otherInsuredIdentifier] if attributes.key?(:otherInsuredIdentifier)

          self.other_insured_identifier_type_code = attributes[:otherInsuredIdentifierTypeCode] if attributes.key?(:otherInsuredIdentifierTypeCode)

          self.other_insured_last_name = attributes[:otherInsuredLastName] if attributes.key?(:otherInsuredLastName)

          self.other_insured_middle_name = attributes[:otherInsuredMiddleName] if attributes.key?(:otherInsuredMiddleName)

          self.other_insured_name_suffix = attributes[:otherInsuredNameSuffix] if attributes.key?(:otherInsuredNameSuffix)

          self.other_insured_qualifier = attributes[:otherInsuredQualifier] if attributes.key?(:otherInsuredQualifier)
        end

        # Show invalid properties with the reasons. Usually used together with valid?
        # @return Array for valid properties with the reasons
        def list_invalid_properties
          []
        end

        # Check to see if the all the properties in the model are valid
        # @return true if the model is valid
        def valid?
          other_insured_identifier_type_code_validator = EnumAttributeValidator.new('String', %w[1 2])
          return false unless other_insured_identifier_type_code_validator.valid?(@other_insured_identifier_type_code)

          other_insured_qualifier_validator = EnumAttributeValidator.new('String', %w[1 2])
          return false unless other_insured_qualifier_validator.valid?(@other_insured_qualifier)

          true
        end

        # Custom attribute writer method checking allowed values (enum).
        # @param [Object] other_insured_identifier_type_code Object to be assigned
        def other_insured_identifier_type_code=(other_insured_identifier_type_code)
          validator = EnumAttributeValidator.new('String', %w[MI II])
          unless validator.valid?(other_insured_identifier_type_code)
            raise ArgumentError,
                  %(invalid value for "other_insured_identifier_type_code", must be one of #{validator.allowable_values}.)
          end

          @other_insured_identifier_type_code = other_insured_identifier_type_code
        end

        # Custom attribute writer method checking allowed values (enum).
        # @param [Object] other_insured_qualifier Object to be assigned
        def other_insured_qualifier=(other_insured_qualifier)
          validator = EnumAttributeValidator.new('String', %w[1 2])
          unless validator.valid?(other_insured_qualifier)
            raise ArgumentError,
                  %(invalid value for "other_insured_qualifier", must be one of #{validator.allowable_values}.)
          end

          @other_insured_qualifier = other_insured_qualifier
        end

        # Checks equality by comparing each attribute.
        # @param [Object] Object to be compared
        def ==(other)
          return true if equal?(other)

          self.class == other.class &&
            other_insured_additional_identifier == other.other_insured_additional_identifier &&
            other_insured_address == other.other_insured_address &&
            other_insured_first_name == other.other_insured_first_name &&
            other_insured_identifier == other.other_insured_identifier &&
            other_insured_identifier_type_code == other.other_insured_identifier_type_code &&
            other_insured_last_name == other.other_insured_last_name &&
            other_insured_middle_name == other.other_insured_middle_name &&
            other_insured_name_suffix == other.other_insured_name_suffix &&
            other_insured_qualifier == other.other_insured_qualifier
        end

        # @see the `==` method
        # @param [Object] Object to be compared
        def eql?(other)
          self == other
        end

        # Calculates hash code according to all attributes.
        # @return [Fixnum] Hash code
        def hash
          [other_insured_additional_identifier, other_insured_address, other_insured_first_name, other_insured_identifier,
           other_insured_identifier_type_code, other_insured_last_name, other_insured_middle_name, other_insured_name_suffix, other_insured_qualifier].hash
        end

        # Builds the object from hash
        # @param [Hash] attributes Model attributes in the form of hash
        # @return [Object] Returns the model itself
        def build_from_hash(attributes)
          return nil unless attributes.is_a?(Hash)

          self.class.swagger_types.each_pair do |key, type|
            if type =~ /\AArray<(.*)>/i
              # check to ensure the input is an array given that the attribute
              # is documented as an array but the input is not
              if attributes[self.class.attribute_map[key]].is_a?(Array)
                send("#{key}=", attributes[self.class.attribute_map[key]].map do |v|
                                  _deserialize(Regexp.last_match(1), v)
                                end)
              end
            elsif !attributes[self.class.attribute_map[key]].nil?
              send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
            end
          end

          self
        end

        # Deserializes the data based on type
        # @param string type Data type
        # @param string value Value to be deserialized
        # @return [Object] Deserialized data
        def _deserialize(type, value)
          case type.to_sym
          when :DateTime
            DateTime.parse(value)
          when :Date
            Date.parse(value)
          when :String
            value.to_s
          when :Integer
            value.to_i
          when :Float
            value.to_f
          when :BOOLEAN
            if value.to_s =~ /\A(true|t|yes|y|1)\z/i
              true
            else
              false
            end
          when :Object
            # generic object (usually a Hash), return directly
            value
          when /\AArray<(?<inner_type>.+)>\z/
            inner_type = Regexp.last_match[:inner_type]
            value.map { |v| _deserialize(inner_type, v) }
          when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
            k_type = Regexp.last_match[:k_type]
            v_type = Regexp.last_match[:v_type]
            {}.tap do |hash|
              value.each do |k, v|
                hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
              end
            end
          else # model
            temp_model = SwaggerClient.const_get(type).new
            temp_model.build_from_hash(value)
          end
        end

        # Returns the string representation of the object
        # @return [String] String presentation of the object
        def to_s
          to_hash.to_s
        end

        # to_body is an alias to to_hash (backward compatibility)
        # @return [Hash] Returns the object in the form of hash
        def to_body
          to_hash
        end

        # Returns the object in the form of hash
        # @return [Hash] Returns the object in the form of hash
        def to_hash
          hash = {}
          self.class.attribute_map.each_pair do |attr, param|
            value = send(attr)
            next if value.nil?

            hash[param] = _to_hash(value)
          end
          hash
        end

        # Outputs non-array value in the form of hash
        # For object, use to_hash. Otherwise, just return the value
        # @param [Object] value Any valid value
        # @return [Hash] Returns the value in the form of hash
        def _to_hash(value)
          if value.is_a?(Array)
            value.compact.map { |v| _to_hash(v) }
          elsif value.is_a?(Hash)
            {}.tap do |hash|
              value.each { |k, v| hash[k] = _to_hash(v) }
            end
          elsif value.respond_to? :to_hash
            value.to_hash
          else
            value
          end
        end
      end
    end
  end
end
