# frozen_string_literal: true

# #Medical Network Professional Claims v3
#
# Reference for developers
#
# OpenAPI spec version: v3
#
# Generated by: https://github.com/swagger-api/swagger-codegen.git
# Swagger Codegen version: 2.4.19
#

require 'date'

module ChangeHealthcare
  module ProfessionalClaims
    module SwaggerClient
      class ServiceLineDateInformation
        attr_accessor :begin_therapy_date, :certification_revision_or_recertification_date, :hemoglobin_test_date,
                      :initial_treatment_date, :last_certification_date, :last_x_ray_date, :prescription_date, :serum_creatine_test_date, :shipped_date, :treatment_or_therapy_date

        # Attribute mapping from ruby-style variable name to JSON key.
        def self.attribute_map
          {
            begin_therapy_date: :beginTherapyDate,
            certification_revision_or_recertification_date: :certificationRevisionOrRecertificationDate,
            hemoglobin_test_date: :hemoglobinTestDate,
            initial_treatment_date: :initialTreatmentDate,
            last_certification_date: :lastCertificationDate,
            last_x_ray_date: :lastXRayDate,
            prescription_date: :prescriptionDate,
            serum_creatine_test_date: :serumCreatineTestDate,
            shipped_date: :shippedDate,
            treatment_or_therapy_date: :treatmentOrTherapyDate
          }
        end

        # Attribute type mapping.
        def self.swagger_types
          {
            begin_therapy_date: :String,
            certification_revision_or_recertification_date: :String,
            hemoglobin_test_date: :String,
            initial_treatment_date: :String,
            last_certification_date: :String,
            last_x_ray_date: :String,
            prescription_date: :String,
            serum_creatine_test_date: :String,
            shipped_date: :String,
            treatment_or_therapy_date: :String
          }
        end

        # Initializes the object
        # @param [Hash] attributes Model attributes in the form of hash
        def initialize(attributes = {})
          return unless attributes.is_a?(Hash)

          # convert string to symbol for hash key
          attributes = attributes.transform_keys(&:to_sym)

          self.begin_therapy_date = attributes[:beginTherapyDate] if attributes.key?(:beginTherapyDate)

          self.certification_revision_or_recertification_date = attributes[:certificationRevisionOrRecertificationDate] if attributes.key?(:certificationRevisionOrRecertificationDate)

          self.hemoglobin_test_date = attributes[:hemoglobinTestDate] if attributes.key?(:hemoglobinTestDate)

          self.initial_treatment_date = attributes[:initialTreatmentDate] if attributes.key?(:initialTreatmentDate)

          self.last_certification_date = attributes[:lastCertificationDate] if attributes.key?(:lastCertificationDate)

          self.last_x_ray_date = attributes[:lastXRayDate] if attributes.key?(:lastXRayDate)

          self.prescription_date = attributes[:prescriptionDate] if attributes.key?(:prescriptionDate)

          self.serum_creatine_test_date = attributes[:serumCreatineTestDate] if attributes.key?(:serumCreatineTestDate)

          self.shipped_date = attributes[:shippedDate] if attributes.key?(:shippedDate)

          self.treatment_or_therapy_date = attributes[:treatmentOrTherapyDate] if attributes.key?(:treatmentOrTherapyDate)
        end

        # Show invalid properties with the reasons. Usually used together with valid?
        # @return Array for valid properties with the reasons
        def list_invalid_properties
          []
        end

        # Check to see if the all the properties in the model are valid
        # @return true if the model is valid
        def valid?
          true
        end

        # Checks equality by comparing each attribute.
        # @param [Object] Object to be compared
        def ==(other)
          return true if equal?(other)

          self.class == other.class &&
            begin_therapy_date == other.begin_therapy_date &&
            certification_revision_or_recertification_date == other.certification_revision_or_recertification_date &&
            hemoglobin_test_date == other.hemoglobin_test_date &&
            initial_treatment_date == other.initial_treatment_date &&
            last_certification_date == other.last_certification_date &&
            last_x_ray_date == other.last_x_ray_date &&
            prescription_date == other.prescription_date &&
            serum_creatine_test_date == other.serum_creatine_test_date &&
            shipped_date == other.shipped_date &&
            treatment_or_therapy_date == other.treatment_or_therapy_date
        end

        # @see the `==` method
        # @param [Object] Object to be compared
        def eql?(other)
          self == other
        end

        # Calculates hash code according to all attributes.
        # @return [Fixnum] Hash code
        def hash
          [begin_therapy_date, certification_revision_or_recertification_date, hemoglobin_test_date,
           initial_treatment_date, last_certification_date, last_x_ray_date, prescription_date, serum_creatine_test_date, shipped_date, treatment_or_therapy_date].hash
        end

        # Builds the object from hash
        # @param [Hash] attributes Model attributes in the form of hash
        # @return [Object] Returns the model itself
        def build_from_hash(attributes)
          return nil unless attributes.is_a?(Hash)

          self.class.swagger_types.each_pair do |key, type|
            if type =~ /\AArray<(.*)>/i
              # check to ensure the input is an array given that the attribute
              # is documented as an array but the input is not
              if attributes[self.class.attribute_map[key]].is_a?(Array)
                send("#{key}=", attributes[self.class.attribute_map[key]].map do |v|
                                  _deserialize(Regexp.last_match(1), v)
                                end)
              end
            elsif !attributes[self.class.attribute_map[key]].nil?
              send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
            end
          end

          self
        end

        # Deserializes the data based on type
        # @param string type Data type
        # @param string value Value to be deserialized
        # @return [Object] Deserialized data
        def _deserialize(type, value)
          case type.to_sym
          when :DateTime
            DateTime.parse(value)
          when :Date
            Date.parse(value)
          when :String
            value.to_s
          when :Integer
            value.to_i
          when :Float
            value.to_f
          when :BOOLEAN
            if value.to_s =~ /\A(true|t|yes|y|1)\z/i
              true
            else
              false
            end
          when :Object
            # generic object (usually a Hash), return directly
            value
          when /\AArray<(?<inner_type>.+)>\z/
            inner_type = Regexp.last_match[:inner_type]
            value.map { |v| _deserialize(inner_type, v) }
          when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
            k_type = Regexp.last_match[:k_type]
            v_type = Regexp.last_match[:v_type]
            {}.tap do |hash|
              value.each do |k, v|
                hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
              end
            end
          else # model
            temp_model = SwaggerClient.const_get(type).new
            temp_model.build_from_hash(value)
          end
        end

        # Returns the string representation of the object
        # @return [String] String presentation of the object
        def to_s
          to_hash.to_s
        end

        # to_body is an alias to to_hash (backward compatibility)
        # @return [Hash] Returns the object in the form of hash
        def to_body
          to_hash
        end

        # Returns the object in the form of hash
        # @return [Hash] Returns the object in the form of hash
        def to_hash
          hash = {}
          self.class.attribute_map.each_pair do |attr, param|
            value = send(attr)
            next if value.nil?

            hash[param] = _to_hash(value)
          end
          hash
        end

        # Outputs non-array value in the form of hash
        # For object, use to_hash. Otherwise, just return the value
        # @param [Object] value Any valid value
        # @return [Hash] Returns the value in the form of hash
        def _to_hash(value)
          if value.is_a?(Array)
            value.compact.map { |v| _to_hash(v) }
          elsif value.is_a?(Hash)
            {}.tap do |hash|
              value.each { |k, v| hash[k] = _to_hash(v) }
            end
          elsif value.respond_to? :to_hash
            value.to_hash
          else
            value
          end
        end
      end
    end
  end
end
